package Fb::Cache;

use 5.006;
use strict;
use warnings;

require Exporter;
our @ISA=qw(Exporter);

sub new {
	my ($package,$options)=@_;
	if ( ! $options ) {
		$options={};
	}
	my $self={
		default_expires_in => 3600,
		data => {},
	};
	if ( $options->{default_expires_in} ) {
		$self->{default_expires_in}=$options->{default_expires_in};
	}
	my $me=bless($self,$package);
}


sub set {
	my ($self,$key,$value)=@_;
	if ( ref($value) eq 'CODE' ) {
		$value=&{$value}();
	}
	$self->{data}->{$key}=[time(),$value];
}

sub remove {
	my ($self,$key)=@_;
	delete $self->{data}->{$key};
}

sub get {
	my ($self,$key,%options)=@_;
	my $item=$self->{data}->{$key};
	my $undef=0;
	if ( ! defined($item) ) {
		$undef=1;
	} else {
		if ( ( time() - $item->[0] ) > $self->{default_expires_in} ) {
			delete $self->{data}->{$key};
			$undef=1;
		}
	}
	if ( $undef && defined($options{default}) ) {
		my $value;
		if ( ref($options{default}) eq 'CODE' ) {
			$value=&{$options{default}};
		} else {
			$value=$options{default};
		}
		return $value;
	}
	return $item->[1];
}

1;
